from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Int, File, String, Boolean

Go_Filter_Subset_Pl_V0_1_0 = CommandToolBuilder(tool="go_filter_subset.pl", base_command=["go-filter-subset.pl"], inputs=[ToolInput(tag="in_id", input_type=Int(optional=True), prefix="-id", doc=InputDocumentation(doc="ID to use as leaf node in subgraph. All ancestors of this ID are\nincluded in the exported graph (unless -partial is set)\nMultiple IDs can be passed\n-id ID1 -id ID2 -id ID3 ....etc")), ToolInput(tag="in_subset", input_type=File(optional=True), prefix="-subset", doc=InputDocumentation(doc="Extracts a named subset from the ontology file. (only works with obo\nformat files). For example, a specific GO slim\nONLY terms belonging to the subset are exported - the -partial\noption is automatically set")), ToolInput(tag="in_namespace", input_type=String(optional=True), prefix="-namespace", doc=InputDocumentation(doc="only terms in this namespace")), ToolInput(tag="in_filter_code", input_type=String(optional=True), prefix="-filter_code", doc=InputDocumentation(doc="advanced option\nA subroutine with which the GO::Model::Term object is tested for\ninclusion in the subgraph (all ancestors are automatically included)\nYou should have an understanding of the go-perl object model before\nusing this option\nExample:\ngo-filter-subset -filter_code 'sub {shift->namespace eq 'molecular_function'}' go.obo\n(the same things can be achieved with the -namespace option)")), ToolInput(tag="in_partial", input_type=Boolean(optional=True), prefix="-partial", doc=InputDocumentation(doc="If this is set, then only terms that match the user query are\nincluded. Parentage is set to the next recursive parent node in the\nfilter\nFor example, with the -subset option: if X and Y belong to the\nsubset, and Z does not, and X is_a Z is_a Y, then the exported graph\nwithh have X is_a Y")), ToolInput(tag="in_use_cache", input_type=Boolean(optional=True), prefix="-use_cache", doc=InputDocumentation(doc="If this switch is specified, then caching mode is turned on.\nWith caching mode, the first time you parse a file, then an\nadditional file will be exported in a special format that is fast to\nparse. This file will have the same filename as the original file,\nexcept it will have the '.cache' suffix.\nThe next time you parse the file, this program will automatically\ncheck for the existence of the '.cache' file. If it exists, and is\nmore recent than the file you specified, this is parsed instead. If\nit does not exist, it is rebuilt."))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Go_Filter_Subset_Pl_V0_1_0().translate("wdl", allow_empty_container=True)

